################################################################
# Modifications beyond tkWWW 0.9 are Copyright 1993, 1994 by
# The University of Chicago Biological Sciences Division, Academic Computing
# Philip Stylianos
# Lee Newberg
################################################################

## config.tcl: configuration file for Phoenix user interface
## ==============
## Copyright (C) 1992-1993
## Global Network Academy
## Macvicar Institute for Educational Software Development
##
## See the file COPYRIGHT for conditions

## Conventions:
##   This is the only file the user should have to edit

## *************************
## This file contains user definable parameters
## *************************

proc phxW3ConfigInitialize {} {
    . config -bg gray90
    
    global phxsrcdir
    
    # phxW3ConfigHTTPdRoots is a list of lists.  Each (inner) list
    # is a computer name and the directory which serves as the HTTPd
    # root on that computer.  For instance on our system the URL
    # http://www.bsd.uchicago.edu/index.html corresponds to the file
    # /opt/Nest/index.html so we have the list with
    # "www.bsd.uchicago.edu /opt/Nest".  Other computers on our
    # network share the filesystem with www.bsd.uchicago.edu so they
    # are listed as well.  This list should contain a given computer
    # only if this copy of Phoenix is running on that computer.  It
    # may contain all computers that share a given file system.
    
    global phxW3ConfigHTTPdRoots
    set phxW3ConfigHTTPdRoots [list \
	[list www.bsd.uchicago.edu /opt/Nest] \
	[list bio-1.bsd.uchicago.edu /opt/Nest] \
	[list bio-2.bsd.uchicago.edu /opt/Nest] \
	[list bio-3.bsd.uchicago.edu /opt/Nest] \
	[list bio-4.bsd.uchicago.edu /opt/Nest] \
	[list bio-5.bsd.uchicago.edu /opt/Nest] \
	[list bio-31.bsd.uchicago.edu /opt/Nest] \
	[list bio-32.bsd.uchicago.edu /opt/Nest] \
	[list bio-33.bsd.uchicago.edu /opt/Nest] \
	[list bio-34.bsd.uchicago.edu /opt/Nest] \
	[list bio-35.bsd.uchicago.edu /opt/Nest] \
	[list bio-36.bsd.uchicago.edu /opt/Nest]]
    
    global tkW3ConfigHelpRoot
    set tkW3ConfigHelpRoot http://tk-www.mit.edu:8001/tk-www/help
    
    ## The programs that Phoenix uses
    global tkW3ConfigViewer
    set tkW3ConfigViewer(editor)	emacs
    set tkW3ConfigViewer(terminal)	xterm
    set tkW3ConfigViewer(printer)	lprhtml
    set tkW3ConfigViewer(dvi)		xdvi
    set tkW3ConfigViewer(image)		xli
    set tkW3ConfigViewer(video)		mpeg_play
    set tkW3ConfigViewer(audio)		showaudio
    set tkW3ConfigViewer(postscript)	pageview
    
    global tkW3ConfigImageDirectView
    set tkW3ConfigImageDirectView 1
    
    ## The backend command Phoenix uses
    global tkW3ServerCommand
    set tkW3ServerCommand "phoenix.server -v"
    
    ## *************************
    ## The home page and the start page
    ## *************************
    
    global phxW3ConfigHomePageRejects
    set phxW3ConfigHomePageRejects ""
    phxW3ConfigHomePageInitialize
    
    ## Configure the menus
    
    global tkW3ConfigMenus
    set tkW3ConfigMenus {
	{{file "File" -1} {
	    {"Create New Page" {tkW3EditCreateNewPage [phxW3EditCreateNewPageName]} -1 "<Meta-n>"}
	    {"Open Local..." tkW3FileLoadSource -1 "<Meta-o>"}
	    {"Open..." {DLG:show . .goto_dialog 400 100} -1}
	    {}
	    {"Get Info" phxW3InfoShowInfo -1 }
	    {"Save" { tkW3EditSave} -1 "<Meta-s>"}
	    {"Save As..." {phxW3EditSaveAs} -1}
	    {"Save Text..." tkW3FileSaveText -1}
	    {}
	    {"Print" {DLG:show . .print_dialog} -1}
	    {"Mail..." 
		{DLG:set_entry_value .mail_dialog 2 [tkW3OutputGetTitle];
		 DLG:show . .mail_dialog 400 100} }
	    {}
	    {"Goto Edit Mode" {phxW3ModeToggle} -1}
	    {"Redraw" {phxW3OutputRedraw} -1}
	    {"Reload" {tkW3NavigateReload} -1}
	    {"Clone" {tkW3NavigateClone [tkW3OutputGetAddress]} -1}
	    {"Backtrack" {tkW3NavigateBacktrack} -1}
	    {"Nest" {phxW3ModeRecordAndGoto $tkW3ConfigHomePage} -1}
	    {}
	    {"View HTML" {phxW3ModeToggleHtml} -1}
	    {"Hide Button Bar" {phxW3ModeToggleButtons} -1}
	    {}
	    {"Close" tkW3FileQueryCloseWindow -1}
	}}
	{{edit "Browse" -1} {
	    {"Undo" {phxW3MistakeUndo [focus]} -1 "<Meta-z>"}	
	    {"Redo" {phxW3MistakeRedo [focus]} -1 "<Meta-Z>"}	
	    {}
	    {"Cut" {phxW3ClipboardCut} -1 "<Meta-x>"}	
	    {"Copy" {phxW3ClipboardCopy} -1 "<Meta-c>"} 
	    {"Paste" {phxW3ClipboardPaste} -1 "<Meta-v>"} 
	    {"Clear" {phxW3SelectionDelete} -1 "<Delete>"}
	    {"Select All" {phxW3SelectionAll} -1 "<Meta-a>"}
	    {"Select None" {phxW3SelectionNone} -1 "<Meta-A>"}
	    {}
	    {"Edit Anchor..." {phxW3AnchorDialog}  -1 ""}
	    {"Insert Image..." {phxW3WidgetInsertImage}  -1 "<Meta-i>"}
	    {"Query..." {DLG:show . .find_dialog 300 70} -1 "<Meta-f>"}
	    {}
	    {"Reauthorize" {phxW3AuthorizationReauthorize} -1 ""}
	}}
	{{format "Format" -1} {
	    {"Plain" "tkW3EditSetCharStyle {}
		    tkW3EditSetParaStyle {}" -1 "<Meta-Key-0>"}
	    {"Address" "tkW3EditSetParaStyle ADDRESS" -1 }
	    {"Cite" "tkW3EditSetCharStyle CITE" -1 }
	    {"Code" "tkW3EditSetCharStyle CODE" -1 }
	    {"Definition" "tkW3EditSetCharStyle DFN" -1 }
	    {"Emphasis" "tkW3EditSetCharStyle EM" -1 }
	    {"Keyboard" "tkW3EditSetCharStyle KBD" -1 }
	    {"Sample" "tkW3EditSetCharStyle SAMP" -1 }
	    {"Strong Emphasis" "tkW3EditSetCharStyle STRONG" -1 }
	    {"Variable" "tkW3EditSetCharStyle VAR" -1 }
	    {}
	    {"Chapter title" "tkW3EditSetParaStyle H1" -1 "<Meta-Key-1>"}
	    {"Section title" "tkW3EditSetParaStyle H2" -1 "<Meta-Key-2>"}
	    {"Subsection title" "tkW3EditSetParaStyle H3" -1 "<Meta-Key-3>"}
	    {"Subsubsection title" "tkW3EditSetParaStyle H4" -1 "<Meta-Key-4>"}
	    {"Paragraph title" "tkW3EditSetParaStyle H5" -1 "<Meta-Key-5>"}
	    {"SubParagraph title" "tkW3EditSetParaStyle H6" -1 "<Meta-Key-6>"}
	    {"Preformatted text" "tkW3EditSetParaStyle PRE" -1 }
	    {}
	    {"Bold" "tkW3EditSetCharStyle B" -1 }
	    {"Italics" "tkW3EditSetCharStyle I" -1 }
	    {"Underline" "tkW3EditSetCharStyle U" -1 }
	    {"Teletype" "tkW3EditSetCharStyle TT" -1 }
	    {}
	    {"Create List" cascade
		    {{ "Unordered List" "phxW3EditBeginList UL" -1 }
		     { "Ordered List" "phxW3EditBeginList OL" -1 }
		     { "Definition List" "phxW3EditBeginList DL" -1 }
		     { "Blockquote" "phxW3EditBeginList BLOCKQUOTE" -1 }}}
	    {"Create List Item" "tkW3EditBeginListItem" -1 }
	}}
	{{font "Font" -1} {
	}}
	{{history "History" -1} {
	}}
	{{hotlist "Hotlist" -1} {
	    {"Add Page to Hotlist" phxW3HotlistAddPage -1}
	    {"Delete from Hotlist..." phxW3HotlistDelete -1}
	    {}
	}}
	{{annotate "Annotate" -1} {
	    {"Add Annotation..." tkW3AnnotateAdd}
	    {"Edit Annotation..." tkW3AnnotateEdit}
	    {}
	    {"Goto Annotation" cascade_external annotate}
	}}
    }
    
    
    # The CharStyles and ParaStyles exist in three places: (Merge, if possible!!)
    #    phxW3FontNew
    #    config.tcl
    #    phxW3EditConvertToHTML
    global phxW3EditCharStyles phxW3EditParaStyles phxW3EditListStyles
    set phxW3EditCharStyles {ADDRESS B CITE CODE DFN EM I KBD SAMP STRONG TT U VAR}
    set phxW3EditParaStyles {H1 H2 H3 H4 H5 H6 PRE XMP}
    set phxW3EditListStyles {UL, OL, DL, DLC, BLOCKQUOTE}
    
    global tkW3ConfigEntries
    set tkW3ConfigEntries {
	{para "Paragraph: "}
	{char "Character: "}
    }
    
    global tkW3ConfigButtons
    set tkW3ConfigButtons [list \
	[list mode "@$phxsrcdir/mode1.icon" {phxW3ModeToggle} "" ""] \
	{space1 "" "" "" "-fill both -expand yes"} \
	{redraw "Redraw" {phxW3OutputRedraw} "" ""} \
	{reload "Reload" {tkW3NavigateReload} "" ""} \
	{save "Save" {tkW3EditSave} "" ""} \
	{space2 "" "" "" "-fill both -expand yes"} \
	{clone "Clone" {tkW3NavigateClone [tkW3OutputGetAddress]} "" ""} \
	{find "Query" {DLG:show . .find_dialog} "" ""} \
	{hot "Mark" {phxW3HotlistAddPage} "" ""} \
	{space3 "" "" "" "-fill both -expand yes"} \
	{open "Open" {DLG:show . .goto_dialog 400 100} "" ""} \
	{back "Back" {tkW3NavigateBacktrack} "-height 2" ""} \
	[list home "@$phxsrcdir/nest.icon" \
	    {phxW3ModeRecordAndGoto $tkW3ConfigHomePage} "" ""] \
    ]
    
    global tkW3ConfigToggles
    set tkW3ConfigToggles {
	{is_index "Is Index"}
	{has_annotation "Has Annotations"}
    }
    
    global tkW3ConfigFileSuffixes
    set tkW3ConfigFileSuffixes   {
	{".mime" "www/mime" "8bit" 1.0} 
	{".PS" "application/postscript" "8bit" 0.8}
	{".eps" "application/postscript" "8bit" 0.8}
	{".ai" "application/postscript" "8bit" 0.5}
	{".ps" "application/postscript" "8bit" 0.8}
	{".html" "text/html" "8bit" 1.0} 
	{".c" "text/plain" "7bit" 0.5}
	{".h" "text/plain" "7bit" 0.5} 
	{".m" "text/plain" "7bit" 0.5} 
	{".txt" "text/plain" "7bit" 0.5}
	{".rtf" "application/x-rtf" "8bit" 1.0}
	{".snd" "audio/basic" "binary" 1.0}
	{".au" "audio/basic" "binary" 1.0}
	{".bin" "application/octet-stream" "binary" 1.0}
	{".dmp.Z" "image/compressed-x11-dump" "binary" 1.0}
	{".dmp" "image/x11-dump" "binary" 1.0}
	{".pbm.Z" "image/compressed-portable-bitmap" "binary" 1.0}
	{".pbm" "image/portable-bitmap" "binary" 1.0}
	{".ppm.Z" "image/compressed-portable-pixmap" "binary" 1.0}
	{".ppm" "image/portable-pixmap" "binary" 1.0}
	{".xbm" "image/x-bitmap" "binary" 1.0} 
	{".xbm.Z" "image/compressed-xbm" "binary" 1.0}
	{".gif.Z" "image/compressed-gif" "binary" 1.0}
	{".gif" "image/gif" "binary" 1.0}
	{".tiff" "image/x-tiff" "binary" 1.0}
	{".jpg" "image/jpeg" "binary" 1.0}
	{".JPG" "image/jpeg" "binary" 1.0}
	{".JPEG" "image/jpeg" "binary" 1.0}
	{".jpeg" "image/jpeg" "binary" 1.0}
	{".ras" "image/cmu-raster" "binary" 1.0}
	{".MPEG" "video/mpeg" "binary" 1.0}
	{".mpg" "video/mpeg" "binary" 1.0}
	{".MPG" "video/mpeg" "binary" 1.0}
	{".mpeg" "video/mpeg" "binary" 1.0}
	{".tex" "application/tex" "binary" 1.0}
	{".latex" "application/latex" "binary" 1.0}
	{".texi" "application/texinfo" "binary" 1.0}
	{".dvi" "application/dvi" "binary" 1.0}
	{".tar" "archive/tar" "binary" 1.0}
	{".tar.Z" "archive/compressed-tar" "binary" 1.0}
	{".shar" "archive/shar" "binary" 1.0}
	{".shar.Z" "archive/compressed-shar" "binary" 1.0}
	{".Z" "application/x-compressed" "binary" 0.5}
	{".gz" "application/x-zipped" "binary" 0.5}
	{".x11.Z" "image/compressed-x11-dump" "binary" 1.0}
	{".x11" "image/x11-dump" "binary" 1.0}
    }
    
    ## *************************
    ## Set options
    ## *************************
    
    option add *background gray startupFile
    option add *foreground black startupFile
    option add *buttons*relief raised startupFile
    option add *buttons*borderWidth 2 startupFile
    option add *Button.foreground black startupFile
    option add *Button.activeForeground blue startupFile
    option add *Button.background gray startupFile
    option add *Button.activeBackground gray startupFile
    option add *toggles*relief flat startupFile
    option add *toggles*borderWidth 2 startupFile
    option add *Hypertext.Button.relief raised startupFile
    option add *Frame.relief sunken startupFile
    option add *Frame.borderWidth 2 startupFile
    option add *Hypertext*background bisque startupFile
    option add *Text*background grey startupFile
    option add *Text*wrap word startupFile
    option add *Text.relief sunken startupFile
    option add *Text.borderWidth 2 startupFile
    option add *Text.Button.background bisque startupFile
    global phxW3SelectionColor
    set phxW3SelectionColor pink
    option add *Text.selectBackground $phxW3SelectionColor startupFile
    
    option add *Scrollbar.foreground gray startupFile
    option add *Scrollbar*relief flat startupFile
    option add *Scrollbar*background gray40 startupFile
    option add *Scrollbar*borderwidth 1 startupFile
    
    option add *cursor {} startupFile
    option add *Entry.cursor xterm startupFile
    
    ## *************************
    ## Set key bindings
    ## *************************
    
    bind Text <Left> {
      %W mark set insert insert-1c; %W yview -pickplace insert}
    bind Text <Right> {
      %W mark set insert insert+1c; %W yview -pickplace insert}
    bind Text <Up> {
      %W mark set insert insert-1l; %W yview -pickplace insert}
    bind Text <Down> {
      %W mark set insert insert+1l; %W yview -pickplace insert}
    bind Text <Control-a> {
      %W mark set insert "insert linestart"; %W yview -pickplace insert}
    bind Text <Control-b> {
      %W mark set insert insert-1c; %W yview -pickplace insert}
    bind Text <Control-d> {
      %W delete insert insert+1c; %W yview -pickplace insert}
    bind Text <Control-e> {
      %W mark set insert "insert lineend"; %W yview -pickplace insert}
    bind Text <Control-f> {
      %W mark set insert insert+1c; %W yview -pickplace insert}
    bind Text <Meta-h> {
      %W delete "insert linestart" insert; %W yview -pickplace insert}
    bind Text <Control-i> {
      %W inser insert \t; %W yview -pickplace insert}
    bind Text <Control-j> {
      %W inser insert \n; %W yview -pickplace insert}
    bind Text <Control-k> {
      if {[%W compare insert == "insert lineend"]} {
	%W delete insert "insert lineend +1c"
	%W yview -pickplace insert
      } {
	%W delete insert "insert lineend"
	%W yview -pickplace insert}}
    bind Text <Control-l> {
      %W yview -pickplace insert}
    bind Text <Control-m> {
      %W inser insert \n; %W yview -pickplace insert}
    bind Text <Control-n> {
      %W mark set insert insert+1l; %W yview -pickplace insert}
    bind Text <Control-o> {
      %W inser insert \n; %W yview -pickplace insert}
    bind Text <Control-p> {
      %W mark set insert insert-1l; %W yview -pickplace insert}
    bind Text <Control-v> {
      set xfCounter [lindex [%W config -height] 4]
      while {$xfCounter > 0} {
	%W mark set insert insert+1l
	incr xfCounter -1
      }
      %W yview -pickplace insert}
    bind Text <Control-w> {
      catch "%W delete sel.first sel.last"}
    bind Text <Home> { 
      %W mark set insert 1.0; %W yview -pickplace insert}
    bind Text <End> {
      %W mark set insert end; %W yview -pickplace insert}
    bind Text <Prior> {
      set xfCounter [lindex [%W config -height] 4]
      while {$xfCounter > 0} {
	%W mark set insert insert-1l
	incr xfCounter -1
      }
      %W yview -pickplace insert}
    bind Text <Next> {
      set xfCounter [lindex [%W config -height] 4]
      while {$xfCounter > 0} {
	%W mark set insert insert+1l
	incr xfCounter -1
      }
      %W yview -pickplace insert}
    
    
    global tkVersion
    if {$tkVersion >= 3.0} {
    bind Entry <Right> {
      %W icursor [expr [%W index insert]+1]; tk_entrySeeCaret %W }
    bind Entry <Left> {
      %W icursor [expr [%W index insert]-1]; tk_entrySeeCaret %W }
    bind Entry <Control-a> {
      %W icursor 0; %W view 0}
    bind Entry <Control-b> {
      %W icursor [expr [%W index insert]-1]; tk_entrySeeCaret %W}
    bind Entry <Control-d> {
      %W delete [%W index insert]; tk_entrySeeCaret %W }
    bind Entry <Control-e> {
      %W icursor end; tk_entrySeeCaret %W}
    bind Entry <Control-f> {
      %W icursor [expr [%W index insert]+1]; tk_entrySeeCaret %W}
    bind Entry <Control-h> {
      tk_entryBackspace %W; tk_entrySeeCaret %W}
    bind Entry <Meta-h> {
      %W delete 0 insert; %W view insert}
    bind Entry <Control-i> {
      %W insert insert \t; tk_entrySeeCaret %W}
    bind Entry <Control-k> {
      %W delete insert end; tk_entrySeeCaret %W}
    bind Entry <Control-l> {
      tk_entrySeeCaret %W}
    bind Entry <Control-w> {
      catch "%W delete sel.first sel.last"; tk_entrySeeCaret %W}
    } {
    bind Entry <Right> {
      %W cursor [expr [%W index cursor]+1]; tk_entrySeeCaret %W }
    bind Entry <Left> {
      %W cursor [expr [%W index cursor]-1]; tk_entrySeeCaret %W }
    bind Entry <Control-a> {
      %W cursor 0; %W view 0}
    bind Entry <Control-b> {
      %W cursor [expr [%W index cursor]-1]; tk_entrySeeCaret %W}
    bind Entry <Control-d> {
      %W delete [%W index cursor]; tk_entrySeeCaret %W }
    bind Entry <Control-e> {
      %W cursor end; tk_entrySeeCaret %W}
    bind Entry <Control-f> {
      %W cursor [expr [%W index cursor]+1]; tk_entrySeeCaret %W}
    bind Entry <Control-h> {
      tk_entryBackspace %W; tk_entrySeeCaret %W}
    bind Entry <Meta-h> {
      %W delete 0 cursor; %W view cursor}
    bind Entry <Control-i> {
      %W insert cursor \t; tk_entrySeeCaret %W}
    bind Entry <Control-k> {
      %W delete cursor end; tk_entrySeeCaret %W}
    bind Entry <Control-l> {
      tk_entrySeeCaret %W}
    bind Entry <Control-w> {
      catch "%W delete sel.first sel.last"; tk_entrySeeCaret %W}
    }

    # Where to put these??
    bind Text <Button-1> {phxW3SelectionTextareaButtonPress %W @%x,%y}
    bind Entry <Button-1> {phxW3SelectionEntryButtonPress %W @%x}
    
    global phxW3ModeTextState
    set phxW3ModeTextState disabled
    
    global tkW3AnchorSelection tkW3ConfigHomePage
    set tkW3AnchorSelection $tkW3ConfigHomePage
}

## The mail command
proc tkW3ConfigSendMail {to subject body} {
    
    set file [open "| Mail -s \"$subject\" $to" w+]
   
    puts $file $body
    close $file
}
    
# phxW3ConfigHomePageInitialize
# The arguments if any are values which are known to be bad URL's.
    
proc phxW3ConfigHomePageInitialize {args} {
    global envwwwhome envhome
    global tkW3ConfigHomePage tkW3ConfigStartPage phxW3ConfigHomePageRejects
    set phxW3ConfigHomePageRejects [concat $phxW3ConfigHomePageRejects $args]

    set homePage ""
    foreach try {$envwwwhome file:$envhome/.Home.html \
	file:$envhome/WWW/default.html file:/etc/default.html \
	http://www.bsd.uchicago.edu/ http://info.cern.ch/default.html} \
    {
	if {[catch {eval "set value $try"}]} continue
	if {[lsearch $phxW3ConfigHomePageRejects $value] != -1} continue
	set homePage $value
	break
    }
    set tkW3ConfigHomePage $homePage
    set tkW3ConfigStartPage $homePage
}

proc tkW3ConfigDisplay {} {
    global tkW3HistoryStackList tkW3HistoryList
    global tkW3BookmarksList
    global tkW3NavigateIsIndex

	tkW3OutputShowBody
    if {[llength $tkW3HistoryStackList]} {
	.buttons.back configure -state normal
	.menu.file.m entryconfigure "Backtrack" -state normal
    } {
	.buttons.back configure -state disabled
	.menu.file.m entryconfigure "Backtrack" -state disabled
    }
	if {[llength $tkW3HistoryList]} {
		.menu.history config -state normal
	} else {
		.menu.history config -state disabled
	}

	phxW3ModeRefresh
	if {[winfo exists .info]} {
		DLG:invoke_button .info 1
		#phxW3InfoShowInfo
	}

    if {$tkW3NavigateIsIndex} {
	.buttons.find configure -state normal
	.menu.edit.m entryconfigure "Query*" -state normal
	#.toggles.is_index select
	
    } {
	.buttons.find configure -state disabled
	.menu.edit.m entryconfigure "Query*" -state disabled
	#.toggles.is_index deselect
    }
    if [tkW3AnnotateDisplay] {
	#.toggles.has_annotation select
	.menu.annotate.m entryconfigure "Goto*" -state normal
    } {
	#.toggles.has_annotation deselect
	.menu.annotate.m entryconfigure "Goto*" -state disabled
    }

    #if [llength $tkW3BookmarksList] {
	#.menu.bookmarks.m entryconfigure "Goto*" -state normal
    #} {
	#.menu.bookmarks.m entryconfigure "Goto*" -state disabled
    #}
}

proc tkW3ConfigDisplayFile {type file_name } {
    global tkW3ConfigViewer	
    
    case $type {
	"image/*" {
	    tkW3OutputSetBodyToImage $file_name
	    return $file_name
	}
	"video/*" {
	tkW3NavigatePreface {Video file
To display press the button below and wait a few seconds
} {Press here to show video} {Displaying video...} \
"exec $tkW3ConfigViewer(video) $file_name &"
	}
	"audio/*" {
	tkW3NavigatePreface {Audio file
To display press the button below and wait a few seconds
} {Press here to show audio} {Displaying audio...} \
"exec $tkW3ConfigViewer(audio) $file_name &"
	}
	{application/postscript} {
	tkW3NavigatePreface {Postscript file
To display press the button below and wait a few seconds
} {Press here to show postscript} {Displaying Postscript...} \
"exec $tkW3ConfigViewer(postscript) $file_name &"
	}
	{application/dvi} {
	tkW3NavigatePreface {TeX Device Independent file
To display press the button below and wait a few seconds
} {Press here to show DVI file} {Displaying TeX DVI file...} \
"exec $tkW3ConfigViewer(dvi) $file_name &"
	}
	{text/plain} {
	    tkW3OutputSetBodyToFile $file_name
	}
	{application/x-compressed} {
	    case [DLG:question . .graphics_dialog "Compressed File" \
		  "Display as text" "Display as image" "Save file as..."] {
		      {1} {tkW3OutputSetBodyToFile "| zcat $file_name "}
		      {2} {tkW3ImageDisplayFile $file_name}
		      {3} {tkW3OutputSaveFileAs $file_name}
		  } 
	}
	{application/x-zipped} {
	    case [DLG:question . .graphics_dialog "Gzip Compressed File" \
		  "Display as text" "Display as image" "Save file as..."] {
		      {1} {tkW3OutputSetBodyToFile "| gunzip -c $file_name"}
		      {2} {tkW3ImageDisplayFile $file_name}
		      {3} {tkW3OutputSaveFileAs $file_name}
		  }
	}
	{default} {
	    case [DLG:question . .graphics_dialog "Unknown file type" \
		  "Display as text" "Display as image" "Save file as..."] {
		      {1} {tkW3OutputSetBodyToFile $file_name}
		      {2} {tkW3ImageDisplayFile $file_name}
		      {3} {tkW3OutputSaveFileAs $file_name}
		  }
	}
    }
}

