################################################################
# Modifications beyond tkWWW 0.9 are Copyright 1993, 1994 by
# The University of Chicago Biological Sciences Division, Academic Computing
# Philip Stylianos
# Lee Newberg
################################################################

## help.tcl tkW3 help facility
## ==============
## Copyright (C) 1992-1993
## Global Network Academy
## Macvicar Institute for Educational Software Development
##
## See the file COPYRIGHT for conditions

## Conventions:
##   all global visible objects in this file should begin with 
##   tkW3Help

proc tkW3HelpInitialize {} {
    #tkW3HelpCreateWhineDialog . .send_mail_dialog
}

proc tkW3HelpCreateWhineDialog {parent w} {
    global phxW3Version

    DLG:toplevel . $w
    DLG:draw_entries $w {To: Subject:}
    DLG:set_entry_value $w 1 "Bug Report <bugs@bio-3.bsd.uchicago.edu>"
    DLG:set_entry_value $w 2 "Comments on Phoenix Version $phxW3Version"
    
    pack configure 
	[label $w.label -text "Please type your comments below" ] \
	-fill x -side top
    pack configure [text $w.text ] -expand yes -fill both -side top

    DLG:draw_buttons $w [list "Send Mail" "Dismiss" "Help"]
    DLG:bind_button $w 1 "wm withdraw $w ; 
    tkW3ConfigSendMail \
	\[DLG:get_entry_value $w 1\] \[DLG:get_entry_value $w 2\] \
	\[$w.text get 0.0 end\]"

    DLG:bind_button $w 2 "DLG:hide $w"
    DLG:bind_button $w 3 "tkW3HelpNoHelp"
}

proc tkW3HelpNotAvailable {} {
    DLG:information . .not_available \
	"Sorry: This feature is not available yet" "OK"
}

proc tkW3HelpAddToMailingList {} {
    tkW3OutputSetMessage "Sending request to tk-www-request@athena.mit.edu"
    tkW3ConfigSendMail tk-www-request@athena.mit.edu "Subscribe" "Add to list"
    tkW3OutputSetMessage "Request sent to tk-www-request@athena.mit.edu"
}

proc tkW3HelpRemoveFromMailingList {} {
    tkW3OutputSetMessage "Sending request to tk-www-request@athena.mit.edu"
    tkW3ConfigSendMail tk-www-request@athena.mit.edu "Remove" "Remove from list"
    tkW3OutputSetMessage "Request sent to tk-www-request@athena.mit.edu"
}

proc tkW3HelpGetTopic {topic} {
    if {$topic != "no_help"} {
	global tkW3ConfigHelpRoot
	tkW3NavigateClone $tkW3ConfigHelpRoot/$topic.html
    } {
	DLG:information . .no_help \
	    "Sorry: No help is available on this topic yet" "OK"
    }
}


proc tkW3HelpAbout {} {
    global phxW3Version
    global tkW3SourcePath
    DLG:toplevel . .information
    DLG:draw_icon_msg .information @$tkW3SourcePath/bitmap/logo "\
Phoenix Version $phxW3Version
  The changes beyond TkWWW Version 0.9 are Copyright \251 1993,1994
  The University of Chicago, Biological Sciences Division, Academic Computing
  Philip Stylianos
  Lee Newberg
  Tim Pierce

  Please send bug reports to bugs@bio-3.bsd.uchicago.edu

Phoenix is built upon tkWWW Version 0.9:
  by Joseph Wang (joe@athena.mit.edu)
  Copyright \251 1992-1993
  Usenet University -- Global Network Academy (UU-GNA)
  Macvicar Institute for Educational Software Development

  Under the terms of the GNU Public License Version 2.0

  The tk-www mailing list is tk-www@athena.mit.edu
  Send subscription requests to tk-www-request@athena.mit.edu

    DLG:draw_buttons .information "OK"
    DLG:bind_button .information 1 "DLG:destroy .information"
    DLG:show . .information
}

