################################################################
# Modifications beyond tkWWW 0.9 are Copyright 1993, 1994 by
# The University of Chicago Biological Sciences Division, Academic Computing
# Philip Stylianos
# Lee Newberg
################################################################

## parse_args.tcl - Parse command line arguments
## ==============
## Copyright (C) 1992-1993
## Global Network Academy
## Macvicar Institute for Educational Software Development
##
## See the file COPYRIGHT for conditions

set tkW3ParseArgsShowInfo 0

## tkW3ParseArgs: Parse arguments
## ----------
## On entry,
##   argv: command line to parse
## On exit,
##   none
## Side effects,
##   Resets various internal variables 

proc tkW3ParseArgs {argv} {
   global tkW3ConfigStartPage tkW3ConfigHomePage tkW3ParseArgsShowInfo
   global tkW3ParseArgsImages

   set tkW3ParseArgsImages(anchor) ""
   set tkW3ParseArgsImages(ismap) 0

   set argc [llength $argv]
   set iconic 0
   for {set i 0} {$i < $argc} { incr i 1} {
       set flag [string tolower [lindex $argv $i]]
      case  $flag in {
	{-wwwhome} {
	    incr i
	    if {$i < $argc} {
	       set tkW3ConfigHomePage [lindex $argv $i]
	    }
	}
	{-wwwstart} {
	    incr i
	    if {$i < $argc} {
	       set tkW3ConfigStartPage [lindex $argv $i]
	    }
	}
	{-wwwnoinfo} {
	    set tkW3ParseArgsShowInfo 0
	}
	{-wwwiconic} {
	    wm iconify .
	}
	{-wwwiconpos} {
	    incr i
	    if {$i < $argc} {
		set x [lindex $argv $i]
		incr i
		wm iconpos . $x [lindex $argv $i]
	    }
	}
	{-wwwgeometry} {
	    incr i
	    if {$i < $argc} {
		wm geometry . [lindex $argv $i]
	   }
	}
	{-wwwimageanc} {
	    incr i
	    if {$i < $argc} {
		set tkW3ParseArgsImages(anchor) [lindex $argv $i]
	    }
	}
	{-wwwimageismap} {
	    set tkW3ParseArgsImages(ismap) 1
	}
	{-help} {
	    puts stdout "\
Arguments:
   -wwwhome = Set the home page
   -wwwstart = Set the start page
   -wwwnoinfo = Start up Phoenix without showing the info window
   -wwwiconic = Start up Phoenix in iconic mode
   -wwwiconpos x y = Set Phoenix icon position
   -wwwgeometry = Set Phoenix geometry
"
	    exit
	}
	{default} {
	    puts stdout "Phoenix Warning: Unknown command line flag $flag
Type \"phxclone -help\" for valid flags"
	}
    }
  }
}
